// FrameListDlg.cpp : implementation file
//

#include "stdafx.h"
#include "tulsa sample app.h"
#include "FrameListDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFrameListDlg dialog


CFrameListDlg::CFrameListDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFrameListDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFrameListDlg)
	m_FrameNumber = 0;
	m_bEnable = FALSE;
	//}}AFX_DATA_INIT
}


void CFrameListDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFrameListDlg)
	DDX_Control(pDX, IDC_FRAME_LIST, m_FrameListBox);
	DDX_Text(pDX, IDC_FRAME_NUMBER, m_FrameNumber);
	DDX_Check(pDX, IDC_ENABLE, m_bEnable);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFrameListDlg, CDialog)
	//{{AFX_MSG_MAP(CFrameListDlg)
	ON_BN_CLICKED(IDC_ADD, OnAdd)
	ON_BN_CLICKED(IDC_REMOVE, OnRemove)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFrameListDlg message handlers

void CFrameListDlg::OnAdd() 
{
	UpdateData(TRUE);

	char szBuffer[20];
	sprintf(szBuffer, "%u", m_FrameNumber);
	m_FrameListBox.AddString(szBuffer);
}

void CFrameListDlg::OnRemove() 
{
	int Selected = m_FrameListBox.GetCurSel();

	if (Selected != LB_ERR) {
		m_FrameListBox.DeleteString(Selected);
	}
}

void CFrameListDlg::OnOK() 
{
	UpdateData(TRUE);
	
	char szBuffer[20];
	int Count = m_FrameListBox.GetCount();
	Count = min(Count, MAX_FRAME_LIST_ENTRIES);

	m_FrameListCount = 0;
	for (int i = 0; i < Count; i++) {
		m_FrameListBox.GetText(i, szBuffer);
		int Frame = atoi(szBuffer);

		m_FrameList[i] = Frame;
		m_FrameListCount++;
	}
	CDialog::OnOK();
}


BOOL CFrameListDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	char szBuffer[20];
	for (int i = 0; i < m_FrameListCount; i++) {
		sprintf(szBuffer, "%u", m_FrameList[i]);
		m_FrameListBox.AddString(szBuffer);
	}
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
